p5.js
=====

####We have begun work on a new JS client-side library for creating graphic and interactive experiences, based on the core principles of [Processing](http://processing.org). It is currently in development and a beta release will be ready for use and contributions this spring. You can follow along with the progress here until then.


##p5.js library (stable)
`dist/p5.js` is currently the only stable file in the repository


##Documentation

####[> Getting Started](https://github.com/lmccart/p5.js/wiki/Getting-Started)
Create and run your first sketch!
####[> Reference](https://github.com/lmccart/p5.js/wiki/Reference)
The functionality supported by p5.js.
####[> Learning](https://github.com/lmccart/p5.js/wiki/Learning)
Tutorials and short, prototypical examples exploring the basics of programming with p5.js.
####[> Troubleshooting](https://github.com/lmccart/p5.js/wiki/Troubleshooting)
Help with common problems. Coming soon.
####[> Research Documentation](https://github.com/lmccart/p5.js/wiki/Research-Documentation)
This project developed out of a Fellowship with the Processing Foundation exploring the future of Processing with JavaScript. Documentation of research in process and references is here.



##Overview

Development of p5.js starts with the original goal of Processing, to make coding accessible for artists, designers, educators, beginners, and reinterpets this for today, for the web. The library is intended to introduce creative coding, introduce web development, and provide a tie between the two. It it important that while this is accessible for beginners, it’s not a sandbox environment and people develop real web development literacy, and the ability to extend and learn new things on their own.

The web dev space is inundated with web libraries, but a lot of them are very powerful and specific, more like a swiss army knife than a platform, and often not very accessible to beginners. In contrast, p5.js aims to be accessible and broad, allowing people to get started quickly, providing scaffolding to start creating visual and interactive compositions using JavaScript immediately. It then also opens hooks to extend into areas of specific interest, interfacing with existing libraries and tools. The library is not domain specific, it’s useful for general creative coding from drawing, to working with text, images, DOM, etc. 

p5.js is about bringing Processing ideas and community to the JavaScript and the web, rather than emulating Processing/Java through JavaScript. We hope to build a strong support community of users for constructive help, with a focus on teaching and learning.

We have been focusing on language design, development, and documentation, but a p5.js web IDE is also in the plan.


##Development
See the [Development](https://github.com/lmccart/p5.js/wiki/Development) wiki page for details.

